Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.toplink
Class TopLinkTransactionManager

    java.lang.Object
      org.springframework.transaction.support.AbstractPlatformTransactionManager
          org.springframework.orm.toplink.TopLinkTransactionManager

All Implemented Interfaces:
  Serializable, InitializingBean, PlatformTransactionManager, ResourceTransactionManager

    public class TopLinkTransactionManager

extends AbstractPlatformTransactionManager
implements ResourceTransactionManager, InitializingBean

`PlatformTransactionManager` implementation for a single TopLink `SessionFactory`. Binds a TopLink Session from the specified factory to the thread, potentially allowing for one thread-bound Session per factory. `SessionFactoryUtils` and `TopLinkTemplate` are aware of thread-bound Sessions and participate in such transactions automatically. Using either of those or going through `Session.getActiveUnitOfWork()` is required for TopLink access code supporting this transaction handling mechanism.

This transaction manager is appropriate for applications that use a single TopLink SessionFactory for transactional data access. JTA (usually through `JtaTransactionManager`) is necessary for accessing multiple transactional resources within the same transaction. Note that you need to configure TopLink with an appropriate external transaction controller in order to make it participate in JTA transactions.

This transaction manager also supports direct DataSource access within a transaction (i.e. plain JDBC code working with the same DataSource), but only for transactions that are not marked as read-only. This allows for mixing services which access TopLink and services which use plain JDBC (without being aware of TopLink)! Application code needs to stick to the same simple Connection lookup pattern as with `DataSourceTransactionManager` (i.e. `DataSourceUtils.getConnection(javax.sql.DataSource)` or going through a `TransactionAwareDataSourceProxy`).

Note: To be able to register a DataSource's Connection for plain JDBC code, this instance needs to be aware of the DataSource (`setDataSource(javax.sql.DataSource)`). The given DataSource should obviously match the one used by the given TopLink SessionFactory.

On JDBC 3.0, this transaction manager supports nested transactions via JDBC 3.0 Savepoints. The `AbstractPlatformTransactionManager.setNestedTransactionAllowed(boolean)` "nestedTransactionAllowed"} flag defaults to "false", though, as nested transactions will just apply to the JDBC Connection, not to the TopLink PersistenceManager and its cached objects. You can manually set the flag to "true" if you want to use nested transactions for JDBC access code which participates in TopLink transactions (provided that your JDBC driver supports Savepoints). Note that TopLink itself does not support nested transactions! Hence, do not expect TopLink access code to semantically participate in a nested transaction.

Thanks to Slavik Markovich for implementing the initial TopLink support prototype!

Since:
  1.2
Author:
  Juergen Hoeller, James Clark
See Also:
  `setSessionFactory(org.springframework.orm.toplink.SessionFactory)`, `setDataSource(javax.sql.DataSource)`, `LocalSessionFactoryBean`, `SessionFactoryUtils.getSession(org.springframework.orm.toplink.SessionFactory, boolean)`, `SessionFactoryUtils.releaseSession(oracle.toplink.sessions.Session, org.springframework.orm.toplink.SessionFactory)`, `TopLinkTemplate`, `Session.getActiveUnitOfWork()`, `DataSourceUtils.getConnection(javax.sql.DataSource)`, `DataSourceUtils.applyTransactionTimeout(java.sql.Statement, javax.sql.DataSource)`, `DataSourceUtils.releaseConnection(java.sql.Connection, javax.sql.DataSource)`, `JdbcTemplate`, `DataSourceTransactionManager`, `JtaTransactionManager`, Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`AbstractPlatformTransactionManager.SuspendedResourcesHolder`

Field Summary

Fields inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`logger, SYNCHRONIZATION_ALWAYS, SYNCHRONIZATION_NEVER, SYNCHRONIZATION_ON_ACTUAL_TRANSACTION`

Constructor Summary
`TopLinkTransactionManager()` Create a new TopLinkTransactionManager instance.
`TopLinkTransactionManager(SessionFactory sessionFactory)` Create a new TopLinkTransactionManager instance.

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected DataAccessException` | `convertTopLinkAccessException(oracle.toplink.exceptions.TopLinkException ex)` Convert the given TopLinkException to an appropriate exception from the `org.springframework.dao` hierarchy.
`protected void` | `doBegin(Object transaction, TransactionDefinition definition)` Begin a new transaction with semantics according to the given transaction definition.
`protected void` | `doCleanupAfterCompletion(Object transaction)` Cleanup resources after transaction completion.
`protected void` | `doCommit(DefaultTransactionStatus status)` Perform an actual commit of the given transaction.
`protected Object` | `doGetTransaction()` Return a transaction object for the current transaction state.
`protected void` | `doResume(Object transaction, Object suspendedResources)` Resume the resources of the current transaction.
`protected void` | `doRollback(DefaultTransactionStatus status)` Perform an actual rollback of the given transaction.
`protected void` | `doSetRollbackOnly(DefaultTransactionStatus status)` Set the given transaction rollback-only.
`protected Object` | `doSuspend(Object transaction)` Suspend the resources of the current transaction.
`DataSource` | `getDataSource()` Return the JDBC DataSource that this instance manages transactions for.
`protected Connection` | `getJdbcConnection(oracle.toplink.sessions.Session session)` Extract the underlying JDBC Connection from the given TopLink Session.
`SQLExceptionTranslator` | `getJdbcExceptionTranslator()` Return the JDBC exception translator for this transaction manager, if any.
`Object` | `getResourceFactory()` Return the resource factory that this transaction manager operates on, e.g. a JDBC DataSource or a JMS ConnectionFactory.
`SessionFactory` | `getSessionFactory()` Return the SessionFactory that this instance should manage transactions for.
`protected boolean` | `isExistingTransaction(Object transaction)` Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).
`boolean` | `isLazyDatabaseTransaction()` Return whether to lazily start a database transaction within a TopLink transaction.
`void` | `setDataSource(DataSource dataSource)` Set the JDBC DataSource that this instance should manage transactions for.
`void` | `setJdbcExceptionTranslator(SQLExceptionTranslator jdbcExceptionTranslator)` Set the JDBC exception translator for this transaction manager.
`void` | `setLazyDatabaseTransaction(boolean lazyDatabaseTransaction)` Set whether to lazily start a database transaction within a TopLink transaction.
`void` | `setSessionFactory(SessionFactory sessionFactory)` Set the the TopLink SessionFactory to manage transactions for.

Methods inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`commit, determineTimeout, getDefaultTimeout, getTransaction, getTransactionSynchronization, invokeAfterCompletion, isFailEarlyOnGlobalRollbackOnly, isGlobalRollbackOnParticipationFailure, isNestedTransactionAllowed, isRollbackOnCommitFailure, isValidateExistingTransaction, newTransactionStatus, prepareForCommit, registerAfterCompletionWithExistingTransaction, resume, rollback, setDefaultTimeout, setFailEarlyOnGlobalRollbackOnly, setGlobalRollbackOnParticipationFailure, setNestedTransactionAllowed, setRollbackOnCommitFailure, setTransactionSynchronization, setTransactionSynchronizationName, setValidateExistingTransaction, shouldCommitOnGlobalRollbackOnly, suspend, triggerBeforeCommit, triggerBeforeCompletion, useSavepointForNestedTransaction`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.springframework.transaction.PlatformTransactionManager
`commit, getTransaction, rollback`

Constructor Detail

### TopLinkTransactionManager

    public TopLinkTransactionManager()

  Create a new TopLinkTransactionManager instance. A SessionFactory has to be specified to be able to use it.

  See Also:
    `setSessionFactory(org.springframework.orm.toplink.SessionFactory)`

### TopLinkTransactionManager

    public TopLinkTransactionManager(SessionFactory sessionFactory)

  Create a new TopLinkTransactionManager instance.

  Parameters:
    `sessionFactory` - the TopLink SessionFactory to manage transactions for

Method Detail

### setSessionFactory

    public void setSessionFactory(SessionFactory sessionFactory)

  Set the the TopLink SessionFactory to manage transactions for. This will usually be a ServerSessionFactory.

  The passed-in SessionFactory will be asked for a plain Session in case of a read-only transaction (where no active UnitOfWork is supposed to be available), and for a managed Session else (with an active UnitOfWork that will be committed by this transaction manager).

  See Also:
    `ServerSessionFactory`, `SessionFactory.createSession()`, `SessionFactory.createManagedClientSession()`

### getSessionFactory

    public SessionFactory getSessionFactory()

  Return the SessionFactory that this instance should manage transactions for.

### setDataSource

    public void setDataSource(DataSource dataSource)

  Set the JDBC DataSource that this instance should manage transactions for. The DataSource should match the one used by the TopLink SessionFactory: for example, you could specify the same JNDI DataSource for both.

  A transactional JDBC Connection for this DataSource will be provided to application code accessing this DataSource directly via DataSourceUtils or JdbcTemplate. The Connection will be taken from the TopLink Session. This will only happen for transactions that are not marked as read-only. TopLink does not support database transactions for pure read-only operations on a Session (that is, without a UnitOfWork).

  Note that you need to use a TopLink Session with a DatabaseAccessor to allow for exposing TopLink transactions as JDBC transactions. This is the case of all standard TopLink configurations.

  The DataSource specified here should be the target DataSource to manage transactions for, not a TransactionAwareDataSourceProxy. Only data access code may work with TransactionAwareDataSourceProxy, while the transaction manager needs to work on the underlying target DataSource. If there's nevertheless a TransactionAwareDataSourceProxy passed in, it will be unwrapped to extract its target DataSource.

  See Also:
    `TransactionAwareDataSourceProxy`, `DataSourceUtils`, `JdbcTemplate`

### getDataSource

    public DataSource getDataSource()

  Return the JDBC DataSource that this instance manages transactions for.

### setLazyDatabaseTransaction

    public void setLazyDatabaseTransaction(boolean lazyDatabaseTransaction)

  Set whether to lazily start a database transaction within a TopLink transaction.

  By default, database transactions are started early. This allows for reusing the same JDBC Connection throughout an entire transaction, including read operations, and also for exposing TopLink transactions to JDBC access code (working on the same DataSource).

  It is only recommended to switch this flag to "true" when no JDBC access code is involved in any of the transactions, and when it is acceptable to perform read operations outside of the transactional JDBC Connection.

  See Also:
    `setDataSource(javax.sql.DataSource)`, `UnitOfWork.beginEarlyTransaction()`

### isLazyDatabaseTransaction

    public boolean isLazyDatabaseTransaction()

  Return whether to lazily start a database transaction within a TopLink transaction.

### setJdbcExceptionTranslator

    public void setJdbcExceptionTranslator(SQLExceptionTranslator jdbcExceptionTranslator)

  Set the JDBC exception translator for this transaction manager.

  Applied to any SQLException root cause of a TopLink DatabaseException that is thrown on commit. The default is to rely on TopLink's native exception translation.

  Parameters:
    `jdbcExceptionTranslator` - the exception translator
  See Also:
    `DatabaseException`, `SQLErrorCodeSQLExceptionTranslator`, `SQLStateSQLExceptionTranslator`, `setDataSource(javax.sql.DataSource)`

### getJdbcExceptionTranslator

    public SQLExceptionTranslator getJdbcExceptionTranslator()

  Return the JDBC exception translator for this transaction manager, if any.

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### getResourceFactory

    public Object getResourceFactory()

  Description copied from interface: `ResourceTransactionManager`
  Return the resource factory that this transaction manager operates on, e.g. a JDBC DataSource or a JMS ConnectionFactory.

  This target resource factory is usually used as resource key for `TransactionSynchronizationManager`'s resource bindings per thread.

  Specified by:
    `getResourceFactory` in interface `ResourceTransactionManager`
  Returns:
    the target resource factory (never `null`)
  See Also:
    `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`, `TransactionSynchronizationManager.getResource(java.lang.Object)`

### doGetTransaction

    protected Object doGetTransaction()

  Description copied from class: `AbstractPlatformTransactionManager`
  Return a transaction object for the current transaction state.

  The returned object will usually be specific to the concrete transaction manager implementation, carrying corresponding transaction state in a modifiable fashion. This object will be passed into the other template methods (e.g. doBegin and doCommit), either directly or as part of a DefaultTransactionStatus instance.

  The returned object should contain information about any existing transaction, that is, a transaction that has already started before the current `getTransaction` call on the transaction manager. Consequently, a `doGetTransaction` implementation will usually look for an existing transaction and store corresponding state in the returned transaction object.

  Specified by:
    `doGetTransaction` in class `AbstractPlatformTransactionManager`
  Returns:
    the current transaction object
  See Also:
    `AbstractPlatformTransactionManager.doBegin(java.lang.Object, org.springframework.transaction.TransactionDefinition)`, `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `AbstractPlatformTransactionManager.doRollback(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.getTransaction()`

### isExistingTransaction

    protected boolean isExistingTransaction(Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).

  The result will be evaluated according to the specified propagation behavior for the new transaction. An existing transaction might get suspended (in case of PROPAGATION_REQUIRES_NEW), or the new transaction might participate in the existing one (in case of PROPAGATION_REQUIRED).

  The default implementation returns `false`, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

  Overrides:
    `isExistingTransaction` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by doGetTransaction
  Returns:
    if there is an existing transaction
  See Also:
    `AbstractPlatformTransactionManager.doGetTransaction()`

### doBegin

    protected void doBegin(Object transaction,
                           TransactionDefinition definition)

  Description copied from class: `AbstractPlatformTransactionManager`
  Begin a new transaction with semantics according to the given transaction definition. Does not have to care about applying the propagation behavior, as this has already been handled by this abstract manager.

  This method gets called when the transaction manager has decided to actually start a new transaction. Either there wasn't any transaction before, or the previous transaction has been suspended.

  A special scenario is a nested transaction without savepoint: If `useSavepointForNestedTransaction()` returns "false", this method will be called to start a nested transaction when necessary. In such a context, there will be an active transaction: The implementation of this method has to detect this and start an appropriate nested transaction.

  Specified by:
    `doBegin` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
    `definition` - TransactionDefinition instance, describing propagation behavior, isolation level, read-only flag, timeout, and transaction name

### getJdbcConnection

    protected Connection getJdbcConnection(oracle.toplink.sessions.Session session)

  Extract the underlying JDBC Connection from the given TopLink Session.

  Default implementation casts to `oracle.toplink.publicinterface.Session` and fetches the Connection from the DatabaseAccessor exposed there.

  Parameters:
    `session` - the current TopLink Session
  Returns:
    the underlying JDBC Connection, or `null` if none found
  See Also:
    `Session.getAccessor()`, `DatabaseAccessor.getConnection()`

### doSuspend

    protected Object doSuspend(Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Suspend the resources of the current transaction. Transaction synchronization will already have been suspended.

  The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

  Overrides:
    `doSuspend` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
  Returns:
    an object that holds suspended resources (will be kept unexamined for passing it into doResume)
  See Also:
    `AbstractPlatformTransactionManager.doResume(java.lang.Object, java.lang.Object)`

### doResume

    protected void doResume(Object transaction,
                            Object suspendedResources)

  Description copied from class: `AbstractPlatformTransactionManager`
  Resume the resources of the current transaction. Transaction synchronization will be resumed afterwards.

  The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

  Overrides:
    `doResume` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
    `suspendedResources` - the object that holds suspended resources, as returned by doSuspend
  See Also:
    `AbstractPlatformTransactionManager.doSuspend(java.lang.Object)`

### doCommit

    protected void doCommit(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Perform an actual commit of the given transaction.

  An implementation does not need to check the "new transaction" flag or the rollback-only flag; this will already have been handled before. Usually, a straight commit will be performed on the transaction object contained in the passed-in status.

  Specified by:
    `doCommit` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction
  See Also:
    `DefaultTransactionStatus.getTransaction()`

### doRollback

    protected void doRollback(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Perform an actual rollback of the given transaction.

  An implementation does not need to check the "new transaction" flag; this will already have been handled before. Usually, a straight rollback will be performed on the transaction object contained in the passed-in status.

  Specified by:
    `doRollback` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction
  See Also:
    `DefaultTransactionStatus.getTransaction()`

### doSetRollbackOnly

    protected void doSetRollbackOnly(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Set the given transaction rollback-only. Only called on rollback if the current transaction participates in an existing one.

  The default implementation throws an IllegalTransactionStateException, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

  Overrides:
    `doSetRollbackOnly` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction

### doCleanupAfterCompletion

    protected void doCleanupAfterCompletion(Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Cleanup resources after transaction completion.

  Called after `doCommit` and `doRollback` execution, on any outcome. The default implementation does nothing.

  Should not throw any exceptions but just issue warnings on errors.

  Overrides:
    `doCleanupAfterCompletion` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`

### convertTopLinkAccessException

    protected DataAccessException convertTopLinkAccessException(oracle.toplink.exceptions.TopLinkException ex)

  Convert the given TopLinkException to an appropriate exception from the `org.springframework.dao` hierarchy.

  Will automatically apply a specified SQLExceptionTranslator to a TopLink DatabaseException, else rely on TopLink's default translation.

  Parameters:
    `ex` - TopLinkException that occured
  Returns:
    a corresponding DataAccessException
  See Also:
    `SessionFactoryUtils.convertTopLinkAccessException(oracle.toplink.exceptions.TopLinkException)`, `setJdbcExceptionTranslator(org.springframework.jdbc.support.SQLExceptionTranslator)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.